use crate::{utils::validate_field, MainDialogue};
use sea_orm::prelude::*;
use teloxide::{adaptors::Throttle, prelude::*};

/// Function to handle GetLogin state
pub async fn get_login(
    bot: Throttle<Bot>,
    msg: Message,
    db: DatabaseConnection,
    dialogue: MainDialogue,
    next: super::PackagedHandler<String>,
) -> crate::Result<()> {
    super::generic::generic(
        bot,
        msg,
        db,
        dialogue,
        |bot, msg, _, login| {
            Box::pin(async move {
                let is_valid = validate_field(login);
                if !is_valid {
                    let msg = bot
                        .send_message(msg.chat.id, "Invalid login. Try again")
                        .await?;
                    return Ok(Some(msg));
                }
                Ok(None)
            })
        },
        "Couldn't get the text of the message. Send the login again",
        next,
    )
    .await
}
